relativePos = nil
grabBody = 0
grabLength = 0
impulseForce = 0.1
canGrab = true
stamina = 100
staminaRate = 0
staminaVis = 0

uiHandCooldown = 0

function init()
	failSnd = LoadSound("error.ogg")
	heliBeepSnd = LoadSound("warning-beep.ogg")
end

function tick() --input stuff
	if InputDown("grab") then
		if relativePos == nil and InputPressed("grab") then
			if canGrab then
				local camTrans = GetPlayerCameraTransform()
				local dir = TransformToParentVec(camTrans,Vec(0,0,-1))
				local hit, dist, n, s = QueryRaycast(camTrans.pos,dir,5)
				if GetPlayerPickBody() ~= 0 then
					grabBody = GetShapeBody(s)
					grabLength = dist
					relativePos = TransformToLocalPoint(GetBodyTransform(grabBody),VecAdd(camTrans.pos,VecScale(dir,dist)))
				end
			elseif not IsBodyDynamic(GetPlayerPickBody()) then
				uiHandCooldown = 1
				PlaySound(failSnd)
			end
		end
	else
		relativePos = nil
		grabBody=0
		grabCancel=false
	end
	
	--player smashes through glass because uhhhhhh
	local pos = GetPlayerTransform().pos
	local vel = GetPlayerVelocity()
	local dir = VecNormalize(vel)
	local hit, dist, n, s = QueryRaycast(pos,dir,2)
	local hitPos = VecAdd(pos,VecScale(dir,dist))
	if VecLength(vel)>12 and GetShapeMaterialAtPosition(s,hitPos) == "glass" and GetPlayerVehicle() == 0 then
		MakeHole(VecAdd(hitPos,Vec(0,0.6,0)),1,0,0)
		MakeHole(VecAdd(hitPos,Vec(0,1.2,0)),1,0,0)
	end
	
	if staminaRate < 3 then
		SetCameraFov(GetInt("options.gfx.fov")+(staminaRate)*10)
	else
		SetCameraFov(GetInt("options.gfx.fov")+30)
	end
	
	staminaRate = lerp(staminaRate,0,0.05)
	if stamina < 100 then
		staminaVis = lerp(staminaVis,1,0.3)
	else
		staminaVis = lerp(staminaVis,0,0.3)
	end
end

function update() --physics stuff
	if grabBody ~= 0 then
		local camTrans = GetPlayerCameraTransform()
		local worldPos = TransformToParentPoint(GetBodyTransform(grabBody),relativePos)
		local camTargetDir = TransformToParentVec(camTrans,Vec(0,0,-1))
		local vec = VecSub(VecAdd(camTrans.pos,VecScale(camTargetDir,grabLength)),worldPos)
		
		ApplyPlayerImpulse(VecScale(vec,VecLength(vec)*-(impulseForce)))
		local bVel = GetBodyVelocity(grabBody)
		SetPlayerVelocity(VecScale(GetPlayerVelocity(),0.98))
		
		if GetPlayerGrabBody() == 0 and IsBodyDynamic(grabBody) then
			grabBody = 0
		end
	end
	
	if stamina < 0 then
		grabBody = 0
		stamina = 0
		canGrab = false
		uiHandCooldown = 1
		PlaySound(failSnd)
	end
	if stamina > 60 and not canGrab then
		canGrab = true
	end
	if stamina > 100 then
		stamina = 100
	end
	stamina = stamina + 0.15
	if GetBool("level.sandbox") then
		stamina=100
	end
end

function draw() --UI
	UiPush()
	if grabBody ~= 0 and not IsBodyDynamic(grabBody) then
		UiTranslate(UiCenter(),UiMiddle())
		UiAlign("center middle")
		UiImage("ui/hud/crosshair-hand.png")
		
		local camTrans = GetPlayerCameraTransform()
		local worldPos = TransformToParentPoint(GetBodyTransform(grabBody),relativePos)
		local camTargetDir = TransformToParentVec(camTrans,Vec(0,0,-1))
		
		DebugLine(VecAdd(VecScale(camTargetDir,grabLength),camTrans.pos),worldPos,1,1,1,0.5)
	end
	UiPop()
	UiPush()
	if not canGrab then
		UiTranslate(UiCenter(),UiMiddle())
		UiAlign("center middle")
		UiColor(1,0,0,uiHandCooldown)
		UiImage("ui/hud/crosshair-hand.png")
		uiHandCooldown = uiHandCooldown-0.05
	end
	UiPop()
	
	UiPush()
		UiTranslate(50,UiHeight()-100)
		UiColorFilter(1,stamina*0.01,stamina*0.01,staminaVis)
		if not canGrab then
			UiColorFilter(1,0,0)
		end
		
		progressBar(400,50,stamina*0.01)
	UiPop()
end

function ApplyPlayerImpulse(vec)
	SetPlayerVelocity(VecAdd(GetPlayerVelocity(),vec))
	local change = (VecLength(vec)*1.8)
	stamina = stamina - change
	staminaRate = lerp(staminaRate,change,0.2)
end

function lerp(a,b,t) return a * (1-t) + b * t end

function progressBar(w, h, t)
	UiPush()
		UiAlign("left top")
		UiColor(0, 0, 0, 0.5)
		UiImageBox("common/box-solid-10.png", w, h, 6, 6)
		if t > 0 then
			UiTranslate(2, 2)
			w = (w-4)*t
			if w < 12 then w = 12 end
			h = h-4
			UiColor(1,1,1,1)
			UiImageBox("common/box-solid-6.png", w, h, 6, 6)
		end
	UiPop()
end
